﻿// #######################################################################################################
// Program Name: CCR Client.exe
// Author: Brice Hilgemann
// Assistance: Professor Blahnik with TcpClient information, MSDN documentation on sockets
// Last Modified: 2/13/2010
// Status: In Progress
// Usage: Gets the user's IP and Port so that they can then attempt to connect to the server in which to
//        control trains.
// #######################################################################################################

using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace Client
{
    public partial class IPandPortSelect : Form
    {
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//     BEGINNING OF GLOBAL VARIABLES
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        Socket ClientSocket;                        // Socket that will communicate with server


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//     BEGINNING OF CODE AND EVENTS - DEFAULTS AND INITIALIZATION
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        public IPandPortSelect()
        // ################################################################################################################
        //   Standard Form Initialization
        // ################################################################################################################
        {
            InitializeComponent();
        }

        private void IPandPortSelect_Shown(object sender, EventArgs e)
        // ################################################################################################################
        //   Default options set at startup when form is first shown
        // ################################################################################################################
        {
            IPandPortSelect.ActiveForm.StartPosition = FormStartPosition.CenterScreen;    // Default form settings
            IPandPortSelect.ActiveForm.MaximizeBox = false;
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        // ################################################################################################################
        //   Connect button clicked - check over IP and Port to see if it exists, send it across to Form1
        // ################################################################################################################
        {
            IPEndPoint connection;                     // Create connection which is an endpoint for an IP

            try
            {
                IPAddress ipAdd = IPAddress.Parse(textBox1.Text);                      // Parse textbox1 to see if it's in the form of an IP
                connection = new IPEndPoint(ipAdd, Convert.ToInt32(textBox2.Text));    // Convert this IP address and Port into an endpoint

                try
                {
                    ClientSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);         // Use IP and Port for ClientSocket
                    ClientSocket.Connect(connection);

                    if (ClientSocket.Connected)                       // Should error out anyways and get through here no matter what if we're connected
                    {
                        Form1 form1 = new Form1(ClientSocket);
                        form1.FormClosed += new FormClosedEventHandler(form1_FormClosed);     // To close this upon form1 closure
                        form1.Show();
                        this.Hide();
                    }
                }
                catch
                {
                    MessageBox.Show("Issue connecting - please try another IP and Port");
                }
            }
            catch
            {
                MessageBox.Show("Invalid IP Address or Port has been entered");        // Displays if invalid IP Address or Port
                return;
            }
        }

        private void form1_FormClosed(object sender, FormClosedEventArgs e)
        // ################################################################################################################
        //   Will close IPandPortSelect when Form1 is closed
        // ################################################################################################################
        {
            this.Close();
        }

        private void pictureBox2_MouseHover(object sender, EventArgs e)
        // ################################################################################################################
        //   Hovering over the 'Connect' button - swap image
        // ################################################################################################################
        {   pictureBox2.Image = Properties.Resources.connect_over;  }

        private void pictureBox2_MouseLeave(object sender, EventArgs e)
        // ################################################################################################################
        //   Leaving the 'Connect' button - swap image back to usual
        // ################################################################################################################
        {   pictureBox2.Image = Properties.Resources.connect;   }
    }
}
