﻿// #######################################################################################################
// Program Name: CCR Server.exe
// Author: Steve Vandenbush (modified by Brice Hilgemann)
// Last Modified: 2/13/2010
// Status: In Progress
// Usage: Allows a user to select a COM port of which is then utilized for the main program to communicate
//        with the track.  Code taken from Steve Vandenbush's PortSelect.cs for communication between the
//        RS232 serial - to - USB adapter.
// #######################################################################################################

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Server
{
    public partial class ComSelect : Form
    {
        public ComSelect()
        {
            InitializeComponent();
        }

        private void ComSelect_Shown(object sender, EventArgs e)
        {
            refreshButton_Click(null, null);
        }

        private void refreshButton_Click(object sender, EventArgs e)
        {
            availablePorts.Items.Clear();

            foreach (string PortNames in System.IO.Ports.SerialPort.GetPortNames())
            {
                availablePorts.Items.Add(PortNames);
            }

            if (availablePorts.Items.Count > 0)
            {
                availablePorts.SelectedIndex = 0;
            }
            else if (availablePorts.Items.Count <= 0)
            {
                MessageBox.Show("No Ports Available");
            }
        }


        private void portSelectButton_Click(object sender, EventArgs e)
        {
            if (availablePorts.SelectedIndex >= 0)
            {
                string select = availablePorts.SelectedItem.ToString();
                Form1 form1 = new Form1(select);
                form1.FormClosed += new FormClosedEventHandler(form1_FormClosed);     // To close this upon form1 closure
                form1.Show();
                this.Hide();
            }
            else
                MessageBox.Show("No Selection Made");
        }
              
        private void form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            this.Close();
        }

        private void refreshButton_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                refreshButton_Click(null, null);
            }
        }

        private void portSelectButton_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                portSelectButton_Click(null, null);
            }
        }

        private void disconnectToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void helpToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Bring up the help document to assist users



        }
    }
}
